// drvtst.cpp: implementation of the drvtst class.
//
//////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <winioctl.h>
#include "a16chlib.h"
#include "drvtst.h"

BYTE	*lpBuffer0;
BYTE	*lpBuffer1;

BYTE	*BufStart;
BYTE	*AdcBufStart;
DWORD	BufferSize;

BYTE	*IoStart;

int test_chan = 2;

class eepst : public eepReport 
{
public :
	eepst() {};
	virtual ~eepst() {};
	virtual void Status(int msg,int par);
};

void eepst::Status(int msg,int par)
{

	switch(msg) {

		case	EEP_ERASE_ALL_START :
			printf("eeprom erase all start\n");
			break;

		case	EEP_ERASE_ALL_ENDED:
			printf("eeprom erase all ended\n");
			break;

		case	EEP_PROG_START:
			printf("\neeprom Program start\n");
			break;

		case	EEP_PROG_SECTOR :
			printf("eeprom Prog Sector = %8lx\r",par);
			break;


		case	EEP_PROG_ENDED :
			printf("\neeprom Program ended\n");
			break;


		case	EEP_VERIFY_START:
			printf("eeprom Verify start\n");
			break;

		case	EEP_VERIFY_ENDED :
			printf("eeprom Verify ended, errors = %d\n",par);
			break;

		case	EEP_LOAD_FILE:
			printf("eeprom File loading...\n");
			break;

		case	EEP_PROG_FILE_OPEN_ERROR :
			printf("eeprom File not found \n");

			break;

		default :
			break;			
	}
}

eepst est;



// local function types
int	main_init(int ac, char *av[]);
void main_run();
void main_end();
void SaveToFile();
void DumpRegister(int ch,DWORD s,DWORD length);
void DumpMemory(DWORD *s,DWORD length);


void DumpRegister(int ch,DWORD s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(ch,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
	if (length - lines*4) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(ch,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
}

void DumpMemory(DWORD *s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %8lx",*s++);
		}
		printf("\n");
	}

	if (length - lines*4) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %8lx",*s++);
		}
		printf("\n");
	}
}


void ClrMem()
{
	int i;
	WORD *s;
	s = (WORD *)BufStart;
	BufferSize = 0x100000;


	for (i=0;i<(BufferSize>>1);i++) {
		*s++ = (i<<4);
	}
}


void DmaStart(int ch)
{
	DWORD pos;

	WORD *s;
	int i;
	int length = 0x8000;
	int sample_rate = 22050*2;

	DWORD data;


	data = ADDA_GetDigitalTrgStatus(ch);
	ADDA_ClrDigitalTrg(ch,data);
	ADDA_SetDigitalPara(ch,0xf,0);
	ADDA_ClrPosStatus(ch,ADDA_GetPosStatus(0));
	ADDA_SetPosIrqEnable(ch,(1<<15));

	printf("Digital Trg Status = %8lx\n",data);

	for (i=0;i<16;i++) {
		ADDA_SetTrgSrc(ch,i,1<<29);	// always 
	}

//	for (i=8;i<16;i++) {
//		ADDA_SetTrgSrc(ch,i,(1<<31) | (1<<16));	// digital input channel 0 event , pre-trigger event
//	}


	printf("Position initial status\n");
	DumpRegister(0,0xc40,16);
	
	//for (i=0;i<16;i++) {
		ADDA_DmaDacStart(ch,test_chan,length,sample_rate);
		ADDA_DmaAdcStart(ch,test_chan,length,sample_rate);
	//}
	//ADDA_DmaAdcStart(ch,0,length,sample_rate);

	printf("press any key to quit the position event loop \n");

	BYTE *d0 = lpBuffer0;
	BYTE *d1 = lpBuffer1;
	DWORD size = 0;


	// fill the DAC buffer

	s = (WORD *)BufStart;

	*s = 0;
	for (i=0;i<length/2;i++) {

		/*
		if (i%10==0) {
			*s++ = 0;
		}
		else {
			*s++ = 0xffff;
		}
		*/

		*s++ = i*4;

	}



	while (1) {
		ADDA_GetDmaAdcPosOvl(ch,test_chan,&pos);

		ADDA_ReadReg(ch,0x484,&data);
		printf("pos = %d, rpos = %8lx, size=%8lx\n",pos,data,size);

		if (pos==1) {

			/*
			s = (WORD *)BufStart;
			*s = 0;
			for (i=0;i<length/4;i++) {

				
				//if (i&1) {
				//	*s++ = 0xffff;
				//}
				//else {
				//	*s++ = 0;
				//}
				
				
				*s++ = (i<<8);
			}

			*/

			// copy adc data to the memory
			memcpy(d0,AdcBufStart+(pos-1)*length/2,length/2);
			d0 += length/2;
			size += length/2;
		}
		else {

			// pos 2

			/*
			s = (WORD *)BufStart;
			s += length/4;

			for (i=0;i<length/4;i++) {

				
				//if (i&1) {
				//	*s++ = 0xffff;
				//}
				//else {
				//	*s++ = 0;
				//}
				

				*s++ = (0x3fff-(i<<4));
				*(s++) = (i<<8);
			}

			*/
			memcpy(d0,AdcBufStart+(pos-1)*length/2,length/2);
			d0 += length/2;
			size += length/2;
		}

		if (size>=BufferSize) break;
		//printf("Pos = %d\n",pos);
		if (kbhit()) break;
	}
	//if (kbhit()) getch();

	//printf("\nwait for the position event for the channel 16 \n");
	//ADDA_GetPositionOvl(ch,15, &pos);
	//printf("End of position trigger = %8lx\n",pos);

}



void DmaStop(int ch)
{
	for (int i=0;i<16;i++) {
		ADDA_DmaDacStop(ch,i);
		ADDA_DmaAdcStop(ch,i);
	}
}


void DacTest(int ch)
{
	WORD data[16];
	DWORD status,status1;
	int i;

	//ADDA_ReqAdc(ch,(1<<1));
	//Sleep(1);
	//ADDA_ReadAdc(ch,1,&(data[1]));

	//printf("data = %8lx\n",data[1]);

	i=1;

	//for (i=0;i<16;i++) {
		ADDA_PutDac(ch,i,0x8000);
	//}
	//ADDA_PutDac(ch,i,j);

	
	do {
		for (int j=0;j<0x10000;j+=0x100) {
			ADDA_PutDac(ch,i,j);

			//Sleep(1);
			// adc request
			ADDA_ReqAdc(ch,(0x1<<i));
			//while (!ADDA_IsAdcEnded(ch,0));

			Sleep(1);

			//for (i=2;i<3;i++) {
				ADDA_ReadAdc(ch,i,&(data[i]));
			//}

			printf("%2d,%8lx, %8lx\n",i,j,data[i]);

			if (kbhit()) break;
		}
		if (kbhit()) break;
	}
	while (1);
	getch();
	printf("End Dac\n");
}


void giotst()
{

	DWORD data;
	DWORD status;

	// output & input  test

	if (0) {
		while (0) {
			ADDA_OutWrite(0,0xffffffff);
			Sleep(1);
			ADDA_InRead(0,&data);
			printf("read data = %8lx\r",data);
			//ADDA_WriteReg(0,0xa10,0x800000ff);
			//ADDA_WriteReg(0,0xa10,0x80000000);
			ADDA_OutWrite(0,0);
			Sleep(1);
			ADDA_InRead(0,&data);
			printf("read data = %8lx\r",data);
			if (kbhit()) break;
		}
		getch();
	}

	// input interrupt test

	if (1) {

		while (1) {
			ADDA_InIrqSet(0,0,0xffffffff);
			ADDA_InReadOvl(0,&data,&status);
			printf("ReadInterrupt data = %8lx, status = %8lx\n",data,status);
			if (kbhit()) break;
		}
		getch();
	}
}


void SaveToFile()
{
	FILE *fp;
	int i;
	fp = fopen("data0.raw","wb");
	fwrite((void *)lpBuffer0,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);

	fp = fopen("data1.raw","wb");
	fwrite((void *)lpBuffer1,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);
}


int	main_init(int ac, char *av[])
{
	DWORD	dwErrorCode;
	int	ret = 0;


	BufferSize = 0x100000;
	lpBuffer0 = (BYTE *)malloc(BufferSize);
	lpBuffer1 = (BYTE *)malloc(BufferSize);

	ADDA_Init();
	// allocate the user buffer
	printf("Main Init,  card numbers = %d, ID = %d\n",ADDA_GetMaxCards(),ADDA_GetID(0));
	ADDA_GetDacBuf(0,test_chan,&BufStart);

	ADDA_GetAdcBuf(0,test_chan,&AdcBufStart);

	ADDA_SetRpt(0,&est);
	IoStart = ADDA_GetIoStart(0);
	return ret;

}


void main_end()
{
	ADDA_End();
	free(lpBuffer0);
	free(lpBuffer1);
}


void main_run()
{
	char cmd;
	DWORD data = 0xaaaa5555;
	DWORD data1,data2;


	printf("\n\nsa)ve to file, dma_c)apture, dma_st)op, g)et_Info, q)uit :");
	do {

		if (_kbhit()) {

			cmd = _getch();

			printf("\n");

			switch (cmd) {

				case '1' : // dac data output test
					printf("Host DaC test \n");
					DacTest(0);
					break;


				case '2' : // DMA test
					printf("DMA transfer test\n");
					DmaStart(0);
					break;

				case '3' : // DMA stop
					printf("DMA stop\n");
					DmaStop(0);
					break;

				case '4' :// DMA buffer view
					giotst();
					break;

				case '5' : 
					ADDA_GetPosition(0,15,&data);
					data1 = ADDA_GetPosStatus(0);
					ADDA_ReadReg(0,0xc04,&data2);
					printf("Position = %8lx,status = %8lx, irqen=%8lx\n",data,data1,data2);
					DumpRegister(0,0xc40,16);
					break;





				case 'a' : // save buffer to file
					printf("Save buffer contents to file\n");
					SaveToFile();
					break;

				case 'c' : // image capture reload
					printf("Image Capture Start reload mode \n");
					break;

				case 'v' : // view the registers
					printf("View the I/O rigisters, card numbers = %d\n",ADDA_GetMaxCards());
					DumpRegister(0,0,8);
					{
						int i;
						for (i=0; i<1;i++) {
							DumpRegister(i,0x400,0x40);
							//DumpRegister(i,0x800,0x20);
						}
					}
					//DumpRegister(0,0x900,0x20);
					//DumpRegister(0,0xA00,0x20);

					break;

				case 'u' :
					printf("Dump register by io map \n");
					DumpMemory((DWORD *)IoStart,8);
					DumpMemory((DWORD *)(IoStart+0x400),0x40);

					break;


				case 'f' : // flush memory

					printf("flush image buffer\n");
					ClrMem();
					break;

				case 'd' : // dump heap memory
					printf("Dump heap memory\n");
					printf("Start = %8lx\n",BufStart);
					DumpMemory((DWORD *)BufStart,64);
					DumpMemory((DWORD *)(BufStart+0x10000*16),64);
					/*
					DumpMemory((DWORD *)(BufStart+0x10000*17),16);
					DumpMemory((DWORD *)(BufStart+0x10000*18),16);
					DumpMemory((DWORD *)(BufStart+0x10000*19),16);
					DumpMemory((DWORD *)(BufStart+0x10000*20),16);
					DumpMemory((DWORD *)(BufStart+0x10000*21),16);
					DumpMemory((DWORD *)(BufStart+0x10000*22),16);
					DumpMemory((DWORD *)(BufStart+0x10000*23),16);
					DumpMemory((DWORD *)(BufStart+0x10000*24),16);
					DumpMemory((DWORD *)(BufStart+0x10000*25),16);
					DumpMemory((DWORD *)(BufStart+0x10000*26),16);
					DumpMemory((DWORD *)(BufStart+0x10000*27),16);
					DumpMemory((DWORD *)(BufStart+0x10000*28),16);
					DumpMemory((DWORD *)(BufStart+0x10000*29),16);
					DumpMemory((DWORD *)(BufStart+0x10000*30),16);
					DumpMemory((DWORD *)(BufStart+0x10000*31),16);
					*/
					break;

				case 'p' : // eeprom programming
					printf("eeprom program \n");
					if (ADDA_Prog(0,"adio_top.mcs")) {
						printf("Program error!!!!\n");
					}
					else {
						printf("Program OK\n");
					}
					break;


				case 'q' :	// QUIT
					break;

				default :
					printf("Not supported command \n");
			}
			printf("\n\nsa)ve to file, dma_c)apture, dma_st)op, g)et_Info, q)uit :");
		}

	} while (cmd!='q');
}

void main(int ac, char *av[])
{
	if (!main_init(ac, av) ) {
		main_run();
		main_end();
	}
}
